#pragma once

//-----------------------------------------------------------------------------
// by cscho

// CMemoListCtrl
class CMemoListCtrl : public CListCtrl
{
	DECLARE_DYNAMIC(CMemoListCtrl)

public:
	CMemoListCtrl();
	virtual ~CMemoListCtrl();

	typedef enum _inner_item
	{
		LIST_TYPE_NORMAL_TEXT = 0,
		LIST_TYPE_NONHIGHLIGHT_TEXT,
		LIST_TYPE_TRACKTEXT,
		LIST_TYPE_IMAGE,
		LIST_TYPE_PROGRESS
	} EINNER_ITEM;

	typedef enum _progress_state
	{
		PROGRESS_READY = 0,
		PROGRESS_DO,
		PROGRESS_COMPLETE
	} EPROGRESS_STATE;

	typedef struct _list_item_progress
	{
		DWORD			dwLenTotal;
		DWORD			dwLenProgress;
		_progress_state	eState;
	} LIST_ITEM_PROGRESS;

	typedef struct _list_item_type
	{
		int			nSubItem;
		_inner_item	eItemType;
		UINT		uiMsg;
		CWnd*		pWndMaster;
		Image*		pImg;
	} LIST_ITEM_TYPE;

	std::vector<LIST_ITEM_TYPE*>	m_vecListItem;

	CFont		m_fntUnderlineTxt;
	CFont		m_fntNormalTxt;

	int			m_nTrackItem;
	int			m_nTrackSubItem;
	CRect		m_rtTrackOld;
	CRect		m_rtTrackNew;

	int			m_nDownItem;
	int			m_nDownSubItem;

	int			GetColumns();
	int			GetCheckedItem(CUIntArray* puiItem);
	BOOL		GetSubItemRect(int nItem, int nSubItem, int nArea, CRect& rect);
	void		GetHoverListItem(CPoint point, int& nItem, int& nSubItem);
	void		UpdateSubItem(int nItem, int nSubItem);
	//-----------------------------------------------------------------------------
	// by cscho
	// ̹ ÷ ߰
	void		AddListType(int nSubItem, _inner_item eType, CString strImgPath = _T(""), UINT uiMsg = 0, CWnd* pWndMaster = NULL);
	//-----------------------------------------------------------------------------
	void		ClearListType();

	CString		InsertCharToString(CString strOrigin, int nPos, TCHAR ch);

protected:
	afx_msg void OnCustomDraw(NMHDR* pNMHDR, LRESULT* pResult);
	DECLARE_MESSAGE_MAP()
public:	
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
};
//-----------------------------------------------------------------------------
